/*
 * Password Agent for Win32
 *
 *    Constants, Variables, Structures and Function Definitions.
 *
 *                    Copyright (C) 1997-1999  Shuichi Kitaguchi
 */

#ifndef __PWAGENT_H__
#define __PWAGENT_H__


/**** definitions ****/
#define PWAGENT_VERSION        "0.2.7"
#define PWAGENT_NAME           "PwAgent"
#define LOGFILE_NAME           "pwagent.log"

#define PWNUM_MAX              8 /* max 8 passwords */

#define PWAG_SUBKEY            "Software\\Mew"
#define PWAG_SUBKEY_SAVEPASS   "SavePasswords"
#define PWAG_SUBKEY_SYSTEMTIME "st"


#define WM_PWAGENTNOTIFY       (WM_APP+100)
#define WM_TASKTRAY            (WM_APP+101)
#define IDT_PWAGENT            100

#define INIT_ERROR_NONE        0
#define INIT_ERROR_RUNNING     1
#define INIT_ERROR_INIT        2


#define PWAG_PROTOLEN     8
#define PWAG_AUTHLEN      8
#define PWAG_SERVERLEN    64
#define PWAG_USERLEN      16
#define PWAG_PASSWORDLEN  256


/**** variables ****/
extern unsigned short port_num;


#pragma pack(push,1)

/**** structures ****/
typedef struct _ImPassword {
  char  prot[PWAG_PROTOLEN];
  char  auth[PWAG_AUTHLEN];
  char  server[PWAG_SERVERLEN];
  char  user[PWAG_USERLEN];
  char  password[PWAG_PASSWORDLEN];
} ImPassword;

#pragma pack(pop)


/**** functions ****/
BOOL InitSocket( void );
BOOL TermSocket( VOID );
BOOL SendCommand ( LPCSTR, LPSTR );



#endif
